# -*- coding: utf-8 -*-
#MoxSceneLoader 181203 リフレッシュボタンをつけた 
from functools import partial
import maya.cmds as cmds
import os
import subprocess #リストコピーに使う


class MoxSceneLoaderClass(object):
    def __init__(self):
        self.projectsPath = cmds.internalVar(userWorkspaceDir=True)
        self.scencePath = self.projectsPath
        
        cmds.window(t="MoxSceneLoader",sizeable=1, tlb=True,resizeToFitChildren=1)
        
        cmds.frameLayout("Topf",lv=0, bv=0)
        cmds.columnLayout("top", columnAttach=["both",5], rowSpacing=10, adjustableColumn=1)
        cmds.rowLayout("r", nc=2)
        cmds.button("path", l=u"path", c=partial(self.setPath), w=160)
        cmds.button("refresh", l=u"r", c=partial(self.changeScenesList), w=20)
        cmds.setParent("..")
        self.txFie = cmds.textField("path", cc=partial(self.changeScenesList)) 
        cmds.setParent("..")
        
        cmds.paneLayout("pane", configuration='horizontal2', paneSize=[1,0,99])
        self.txScLis = cmds.textScrollList("scenesList", append=self.getSceneList(self.scencePath),sc=partial(self.load), w=100)
        cmds.columnLayout("buttom")
        cmds.rowLayout("a", nc=2)
        self.cbA = cmds.checkBox("AutoPlay")
        self.cbE = cmds.checkBox("ErrorDialog")
        cmds.setParent("..")
        cmds.rowLayout("b", nc=4)
        self.cbM = cmds.checkBox("MeshOnly",v=0)
        cmds.button("listCopyex", c=partial(self.listCopy, True))
        cmds.button("listCopy", c=partial(self.listCopy, False))
        cmds.setParent("..")
        cmds.showWindow()
        
       
    def getSceneList(self, path, *args):
        scenelist=[]
        for scene in os.listdir(path):
            name, ext = os.path.splitext(scene)
            if ext == ".ma" or ext == ".mb":
                scenelist.append(scene)
        return scenelist


    def listCopy(self, ex=True, *args):
        sceneNames = ""
        for sceneName in self.getSceneList(self.scencePath):
            if ex:
                pass
            else:sceneName = sceneName.split(".")[0]
            sceneNames = sceneNames + sceneName + "\n"
        try:
            p = subprocess.Popen( ['clip'], stdin=subprocess.PIPE, shell=True )
            p.stdin.write( sceneNames )
            p.stdin.close()
            retcode = p.wait()
            return True
        except Exception, inst:
            return False
       
    def load(self, *args):
        errorD = cmds.checkBox( self.cbE, q=1, v=1)
            
        selectScene = cmds.textScrollList(self.txScLis, q=True, si=True)[0]
        cmds.file(self.scencePath + '/' + selectScene, f=True, options="v=0;", ignoreVersion=True, o=True, prompt=errorD) 
        if cmds.checkBox(self.cbA, q=True, v=True):
            cmds.play()
        if cmds.checkBox( self.cbM, q=1, v=1):
            selectPanel = cmds.getPanel(wf=1)
            cmds.modelEditor(selectPanel, e=1, allObjects=0)
            cmds.modelEditor(selectPanel, e=1, polymeshes=1,  locators=0 )
        
    def setPath(self,*args):
        self.scencePath = cmds.fileDialog2(dialogStyle=2, okc="Accept",fileMode=3)[0]
        cmds.textScrollList(self.txScLis, e=True, removeAll=True)
        cmds.textScrollList(self.txScLis, e=True, append = self.getSceneList(self.scencePath))
        cmds.textField(self.txFie, e=1, text=self.scencePath)
        
    def changeScenesList(self,*args):
        self.scencePath = cmds.textField(self.txFie, q=1, text=1)
        try:
            cmds.textScrollList(self.txScLis, e=True, removeAll=True)
            cmds.textScrollList(self.txScLis, e=True, append = self.getSceneList(self.scencePath))
        except:
            cmds.warning("not found")
        

MoxSceneLoaderInstance = MoxSceneLoaderClass()
        

